| OpendTect 8.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | Friends | List of all members
Vel::Picks Class Reference
Velocity

`#include <velocitypicks.h>`

Inheritance diagram for Vel::Picks:
[legend]

## Public Types
enum | PickType { RMO , RMS , Delta , Epsilon , Eta }
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Public Member Functions
| Picks (const ZDomain::Info *=nullptr)
void | addHorizon (const MultiID &, bool addzeroonfail=false)
void | addHorizon (EM::Horizon3D *)
uiString | errMsg () const
RowCol | find (const BinID &, const Pick &) const
const MultiID & | gatherID () const
int | get (const BinID &, TypeSet< float > *depths, TypeSet< float > *vals, TypeSet< RowCol > *, TypeSet< EM::ObjectID > *, bool interpolatehors) const
void | get (const BinID &, TypeSet< Pick > &, bool interpolatehors, bool normalizerefoffset) const
void | get (const EM::ObjectID &, TypeSet< RowCol > &) const
bool | get (const RowCol &, BinID &, Pick &)
const MultiDimStorage< Pick > & | getAll () const
const OD::Color & | getColor () const
bool | getDefaultColor (OD::Color &) const
EM::Horizon3D * | getHorizon (EM::ObjectID)
const EM::Horizon3D * | getHorizon (EM::ObjectID) const
EM::ObjectID | getHorizonID (int) const
char | getHorizonStatus (const BinID &) const
Smoother1D< float > * | getSmoother ()
const Smoother1D< float > * | getSmoother () const
const StepInterval< float > & | getSnappingInterval () const
bool | interpolateVelocity (EM::ObjectID, float searchradius, BinIDValueSet &) const
bool | isChanged () const
bool | isEmpty () const
int | nrHorizons () const
PickType | pickType () const
float | refOffset () const
void | remove (const RowCol &, bool undo=true, bool interactionend=true)
void | removeAll (bool undo=true, bool interactionend=true)
void | removeHorizon (EM::ObjectID)
void | resetChangedFlag ()
RowCol | set (const BinID &, const Pick &, bool undo=true, bool interactionend=true)
void | set (const RowCol &, const Pick &, bool undo=true, bool interactionend=true)
void | setAll (float vel, bool undo=true)
bool | setColor (const OD::Color &, bool savedefault)
void | setGatherID (const MultiID &)
void | setPickType (PickType, bool resetcolor)
void | setReferenceOffset (double n)
void | setSmoother (Smoother1D< float > *)
| Becomes mine.
void | setSnappingInterval (const StepInterval< float > &)
const MultiID & | storageID () const
bool | store (const IOObj *)
Undo & | undo ()
const UnitOfMeasure * | velUnit () const
| Only for RMS type.
const ZDomain::Info & | zDomain () const
bool | zInFeet () const
bool | zInMeter () const
bool | zIsTime () const
const UnitOfMeasure * | zUnit () const
Public Member Functions inherited from SharedObject
| SharedObject (const char *nm=nullptr)
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const
Public Member Functions inherited from RefCount::Referenced
void | addObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
int | nrRefs () const
| Only for expert use.
void | ref () const
bool | refIfReffed () const
| Don't use in production, for debugging.
void | removeObserver (WeakPtrBase *obs)
| Not for normal use. May become private.
bool | tryRef () const
| Not for normal use. May become private.
void | unRef () const
void | unRefNoDelete () const

## Static Public Member Functions
static const IOObjContext & | getStorageContext ()
static void | setContextPickType (IOObjContext &, PickType)
static const char * | sKeyGatherID ()
static const char * | sKeyHorizonPrefix ()
static const char * | sKeyNrHorizons ()
static const char * | sKeyPickType ()
static const char * | sKeyRefOffset ()
static const char * | sKeyVelocityPicks ()
Static Public Member Functions inherited from SharedObject
static Notifier< SharedObject > & | instanceCreated ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Static Public Member Functions inherited from RefCount::Referenced
static bool | isSane (const Referenced *)

## Public Attributes
CNotifier< Picks, const BinID & > | change
CNotifier< Picks, const BinID & > | changelate

## Protected Member Functions
virtual | ~Picks ()
void | fillIOObjPar (IOPar &) const
void | fillPar (IOPar &) const
void | getColorKey (BufferString &) const
void | horizonChangeCB (CallBacker *)
bool | load (const IOObj *)
double | normalizeRMO (float depth, float rmo, float offset) const
void | removeHorizons ()
Picks & | setZDomain (const ZDomain::Info &)
bool | useIOObjPar (const IOPar &)
bool | usePar (const IOPar &)
Protected Member Functions inherited from SharedObject
| ~SharedObject ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const
Protected Member Functions inherited from RefCount::Referenced
| Referenced ()
| Referenced (const Referenced &)
virtual | ~Referenced ()
Referenced & | operator= (const Referenced &)

## Protected Attributes
bool | changed_ = false
OD::Color | color_
uiString | errmsg_
MultiID | gatherid_
ObjectSet< EM::Horizon3D > | horizons_
MultiDimStorage< Pick > | picks_
PickType | picktype_
double | refoffset_ = 0.
Smoother1D< float > * | smoother_ = nullptr
StepInterval< float > | snapper_
MultiID | storageid_
Undo * | undo_ = nullptr
const ZDomain::Info * | zdomaininfo_
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Friends
class | PicksMgr

## Detailed Description

Holds picks that the user has done, typically in a semblance plot.

<>

## Member Enumeration Documentation

## ◆ PickType

enum Vel::Picks::PickType

Enumerator
RMO |
RMS |
Delta |
Epsilon |
Eta |

## Constructor & Destructor Documentation

## ◆ Picks()

Vel::Picks::Picks | ( | const ZDomain::Info * | = nullptr | ) |

## ◆ ~Picks()

virtual Vel::Picks::~Picks | ( |  | ) |
| protected virtual

## Member Function Documentation

## ◆ addHorizon() [1/2]

void Vel::Picks::addHorizon | ( | const MultiID & | ,
|  | bool | addzeroonfail = false )

## ◆ addHorizon() [2/2]

void Vel::Picks::addHorizon | ( | EM::Horizon3D * |  | ) |

## ◆ errMsg()

uiString Vel::Picks::errMsg | ( |  | ) | const

## ◆ fillIOObjPar()

void Vel::Picks::fillIOObjPar | ( | IOPar & |  | ) | const
| protected

## ◆ fillPar()

void Vel::Picks::fillPar | ( | IOPar & |  | ) | const
| protected

## ◆ find()

RowCol Vel::Picks::find | ( | const BinID & | ,
|  | const Pick & | ) const

## ◆ gatherID()

const MultiID & Vel::Picks::gatherID | ( |  | ) | const

## ◆ get() [1/4]

int Vel::Picks::get | ( | const BinID & | ,
|  | TypeSet< float > * | depths,
|  | TypeSet< float > * | vals,
|  | TypeSet< RowCol > * | ,
|  | TypeSet< EM::ObjectID > * | ,
|  | bool | interpolatehors ) const

Returns
  number of picks

## ◆ get() [2/4]

void Vel::Picks::get | ( | const BinID & | ,
|  | TypeSet< Pick > & | ,
|  | bool | interpolatehors,
|  | bool | normalizerefoffset ) const

Returns
  number of picks

## ◆ get() [3/4]

void Vel::Picks::get | ( | const EM::ObjectID & | ,
|  | TypeSet< RowCol > & | ) const

## ◆ get() [4/4]

bool Vel::Picks::get | ( | const RowCol & | ,
|  | BinID & | ,
|  | Pick & | )

## ◆ getAll()

const MultiDimStorage< Pick > & Vel::Picks::getAll | ( |  | ) | const
| inline

## ◆ getColor()

const OD::Color & Vel::Picks::getColor | ( |  | ) | const
| inline

## ◆ getColorKey()

void Vel::Picks::getColorKey | ( | BufferString & |  | ) | const
| protected

## ◆ getDefaultColor()

bool Vel::Picks::getDefaultColor | ( | OD::Color & |  | ) | const

## ◆ getHorizon() [1/2]

EM::Horizon3D * Vel::Picks::getHorizon | ( | EM::ObjectID |  | ) |

## ◆ getHorizon() [2/2]

const EM::Horizon3D * Vel::Picks::getHorizon | ( | EM::ObjectID |  | ) | const

## ◆ getHorizonID()

EM::ObjectID Vel::Picks::getHorizonID | ( | int |  | ) | const

## ◆ getHorizonStatus()

char Vel::Picks::getHorizonStatus | ( | const BinID & |  | ) | const

Return values

  0 | no defined hors.
  1 | some defined, some undefined.
  2 | all defined.

## ◆ getSmoother() [1/2]

Smoother1D< float > * Vel::Picks::getSmoother | ( |  | ) |
| inline

## ◆ getSmoother() [2/2]

const Smoother1D< float > * Vel::Picks::getSmoother | ( |  | ) | const
| inline

## ◆ getSnappingInterval()

const StepInterval< float > & Vel::Picks::getSnappingInterval | ( |  | ) | const
| inline

## ◆ getStorageContext()

static const IOObjContext & Vel::Picks::getStorageContext | ( |  | ) |
| static

## ◆ horizonChangeCB()

void Vel::Picks::horizonChangeCB | ( | CallBacker * |  | ) |
| protected

## ◆ interpolateVelocity()

bool Vel::Picks::interpolateVelocity | ( | EM::ObjectID | ,
|  | float | searchradius,
|  | BinIDValueSet & | ) const

Interpolates vel at all locations in the valset. First value in valset will be horizon depth, second will be velocity.

## ◆ isChanged()

bool Vel::Picks::isChanged | ( |  | ) | const

## ◆ isEmpty()

bool Vel::Picks::isEmpty | ( |  | ) | const

## ◆ load()

bool Vel::Picks::load | ( | const IOObj * |  | ) |
| protected

## ◆ normalizeRMO()

double Vel::Picks::normalizeRMO | ( | float | depth,
|  | float | rmo,
|  | float | offset ) const
| protected

Given an rmo at a certain offset, what is the rmo at refoffset_.

## ◆ nrHorizons()

int Vel::Picks::nrHorizons | ( |  | ) | const

## ◆ pickType()

PickType Vel::Picks::pickType | ( |  | ) | const

## ◆ refOffset()

float Vel::Picks::refOffset | ( |  | ) | const
| inline

## ◆ remove()

void Vel::Picks::remove | ( | const RowCol & | ,
|  | bool | undo = true,
|  | bool | interactionend = true )

## ◆ removeAll()

void Vel::Picks::removeAll | ( | bool | undo = true,
|  | bool | interactionend = true )

## ◆ removeHorizon()

void Vel::Picks::removeHorizon | ( | EM::ObjectID |  | ) |

## ◆ removeHorizons()

void Vel::Picks::removeHorizons | ( |  | ) |
| protected

## ◆ resetChangedFlag()

void Vel::Picks::resetChangedFlag | ( |  | ) |
| inline

## ◆ set() [1/2]

RowCol Vel::Picks::set | ( | const BinID & | ,
|  | const Pick & | ,
|  | bool | undo = true,
|  | bool | interactionend = true )

## ◆ set() [2/2]

void Vel::Picks::set | ( | const RowCol & | ,
|  | const Pick & | ,
|  | bool | undo = true,
|  | bool | interactionend = true )

## ◆ setAll()

void Vel::Picks::setAll | ( | float | vel,
|  | bool | undo = true )

## ◆ setColor()

bool Vel::Picks::setColor | ( | const OD::Color & | ,
|  | bool | savedefault )

Returns
  false if savedefault failed.

## ◆ setContextPickType()

static void Vel::Picks::setContextPickType | ( | IOObjContext & | ,
|  | PickType | )
| static

## ◆ setGatherID()

void Vel::Picks::setGatherID | ( | const MultiID & |  | ) |

## ◆ setPickType()

void Vel::Picks::setPickType | ( | PickType | ,
|  | bool | resetcolor )

## ◆ setReferenceOffset()

void Vel::Picks::setReferenceOffset | ( | double | n | ) |

## ◆ setSmoother()

void Vel::Picks::setSmoother | ( | Smoother1D< float > * |  | ) |

Becomes mine.

## ◆ setSnappingInterval()

void Vel::Picks::setSnappingInterval | ( | const StepInterval< float > & |  | ) |

## ◆ setZDomain()

Picks & Vel::Picks::setZDomain | ( | const ZDomain::Info & |  | ) |
| protected

## ◆ sKeyGatherID()

static const char * Vel::Picks::sKeyGatherID | ( |  | ) |
| static

## ◆ sKeyHorizonPrefix()

static const char * Vel::Picks::sKeyHorizonPrefix | ( |  | ) |
| static

## ◆ sKeyNrHorizons()

static const char * Vel::Picks::sKeyNrHorizons | ( |  | ) |
| static

## ◆ sKeyPickType()

static const char * Vel::Picks::sKeyPickType | ( |  | ) |
| static

## ◆ sKeyRefOffset()

static const char * Vel::Picks::sKeyRefOffset | ( |  | ) |
| static

## ◆ sKeyVelocityPicks()

static const char * Vel::Picks::sKeyVelocityPicks | ( |  | ) |
| static

## ◆ storageID()

const MultiID & Vel::Picks::storageID | ( |  | ) | const

## ◆ store()

bool Vel::Picks::store | ( | const IOObj * |  | ) |

ioobj is not transferred

## ◆ undo()

Undo & Vel::Picks::undo | ( |  | ) |

## ◆ useIOObjPar()

bool Vel::Picks::useIOObjPar | ( | const IOPar & |  | ) |
| protected

## ◆ usePar()

bool Vel::Picks::usePar | ( | const IOPar & |  | ) |
| protected

## ◆ velUnit()

const UnitOfMeasure * Vel::Picks::velUnit | ( |  | ) | const

Only for RMS type.

## ◆ zDomain()

const ZDomain::Info & Vel::Picks::zDomain | ( |  | ) | const

## ◆ zInFeet()

bool Vel::Picks::zInFeet | ( |  | ) | const

## ◆ zInMeter()

bool Vel::Picks::zInMeter | ( |  | ) | const

## ◆ zIsTime()

bool Vel::Picks::zIsTime | ( |  | ) | const

## ◆ zUnit()

const UnitOfMeasure * Vel::Picks::zUnit | ( |  | ) | const

## Friends And Related Symbol Documentation

## ◆ PicksMgr

friend class PicksMgr
| friend

## Member Data Documentation

## ◆ change

CNotifier<Picks,const BinID&> Vel::Picks::change

## ◆ changed_

bool Vel::Picks::changed_ = false
| protected

## ◆ changelate

CNotifier<Picks,const BinID&> Vel::Picks::changelate

Triggers after pickchange.

## ◆ color_

OD::Color Vel::Picks::color_
| protected

## ◆ errmsg_

uiString Vel::Picks::errmsg_
| protected

## ◆ gatherid_

MultiID Vel::Picks::gatherid_
| protected

## ◆ horizons_

ObjectSet<EM::Horizon3D> Vel::Picks::horizons_
| protected

## ◆ picks_

MultiDimStorage<Pick> Vel::Picks::picks_
| protected

## ◆ picktype_

PickType Vel::Picks::picktype_
| protected

## ◆ refoffset_

double Vel::Picks::refoffset_ = 0.
| protected

## ◆ smoother_

Smoother1D<float>* Vel::Picks::smoother_ = nullptr
| protected

## ◆ snapper_

StepInterval<float> Vel::Picks::snapper_
| protected

## ◆ storageid_

MultiID Vel::Picks::storageid_
| protected

## ◆ undo_

Undo* Vel::Picks::undo_ = nullptr
| protected

## ◆ zdomaininfo_

const ZDomain::Info* Vel::Picks::zdomaininfo_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025